//+------------------------------------------------------------------+
//|                                                      gg53kf.mq4  |
//|   Ref:di2bardvg.mq4                gg53kf= dp killing field Indic|
//|                                    ApacheSoft Copyright  2012   |
//|                      			      	 	w.Apache Soft Works PL  |
//|                         Based on gg53 killing field thread       |
//| The Indicator signals when current bar is T times greater than   |
//| previous bar to mark the start of killing field.                 |
//+------------------------------------------------------------------+
#property copyright "ApacheSoft Copyright  2011"
#property link      "www.Apache Soft Works PL"
//----
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Aqua//LightBlue
#property indicator_color4 Aqua//LightBlue//DeepPink
#property indicator_color5 DeepPink
#property indicator_color6 DeepPink
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
//----


extern int     ChartTF=0;//1=1M,5=5M,15=15M,30=30M,60=1H,240=4H,1440=D
extern double   T=1.8;//Times prev bar Factor
extern int     AtrPd=14; 


extern bool Show_Alert = true;
extern bool Display_Bearish_Engulfing = true;
extern bool Display_Bullish_Engulfing = true;
//---- buffers
double upArrow[];//UpTrend PullBack Breakout Retrace
double downArrow[];//TrendPullback Breakout
double ReverUP[];//Reversal Up
double RevDown[];//Reversal
double BearDown[];
double BearUp[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0, DRAW_ARROW, 0, 4,Red);
   SetIndexArrow(0, 242);//Thumb Dn=68,Solid Dn Arrow=234
   SetIndexBuffer(0, downArrow);      
//----
   SetIndexStyle(1, DRAW_ARROW, 0, 4,Red);
   SetIndexArrow(1, 241); //Thumb UP=67,Solid Up Arrow=233
   SetIndexBuffer(1, upArrow);
   
  SetIndexStyle(2, DRAW_ARROW, 0, 4,LightBlue);
   SetIndexArrow(2, 233);
   SetIndexBuffer(2, ReverUP); 
    
   SetIndexStyle(3, DRAW_ARROW,  0,LightBlue);
   SetIndexArrow(3, 234); //Hollow Down Arrow=242
   SetIndexBuffer(3, RevDown);  
   
   SetIndexStyle(4, DRAW_ARROW,  0,DeepPink);
   SetIndexArrow(4, 241); //Hollow Down Arrow=242
   SetIndexBuffer(4, BearDown); 
      
   SetIndexStyle(5, DRAW_ARROW,  0,DeepPink);
   SetIndexArrow(5, 242); //Hollow Down Arrow=242
   SetIndexBuffer(5, BearUp); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   double Range,AvDR, AvgRange;
   int counter, setalert;
  
   int shift;
   int shift1;
   int shift2;
   int shift3;
   int shift4;
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   int arrowShift;
   int textShift;
   double O, O1, O2, C, C1, C2,C3, L, L1, L2, H, H1, H2;     
//----
   
   for(shift = 0; shift < Bars; shift++) 
     {
       setalert = 0;
       counter = shift;
       Range = 0;
       AvgRange = 0;
       for(counter = shift; counter <= shift + 9; counter++) 
         {
           AvgRange = AvgRange + MathAbs(High[counter] - Low[counter]);
         }
       Range = AvgRange / 10;
       shift1 = shift + 1;
       shift2 = shift + 2;
       shift3 = shift + 3; 
       shift4 = shift + 4;     
       O = Open[shift1];
       double Oabs=MathAbs(Open[shift1]);
      // O1 = Open[shift2];
      double O1abs=MathAbs(Open[shift2]);
       //O2 = Open[shift3];
      H = High[shift1];
       H1 = High[shift2];
      // H2 = High[shift3];
       L = Low[shift1];
       L1 = Low[shift2];
      // L2 = Low[shift3];
       C = Close[shift1];
       double Cabs=MathAbs(Open[shift1]);
       C1 = Close[shift2];
       double C1abs=MathAbs(Open[shift2]);
       C2 = Close[shift3]; 
       C3= Close[shift4]; 
        double BBabs=MathAbs(Open[shift1]-Close[shift1]); 
        double BB1abs=MathAbs(Open[shift2]-Close[shift2]);   
       AvDR=iATR( NULL, ChartTF,AtrPd, shift);     
       
    // if ((H-L)>T*AvDR)
    // if ((H-L)>T*(H1-L1))
      if ((BBabs)>T*(BB1abs))
     
         {
           if(Display_Bearish_Engulfing == true) 
             {
              
              downArrow[shift1] = High[shift1] + Range*0.55;
              upArrow[shift1] = Low[shift1] - Range*0.55;
             }
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Bearish Engulfing Pattern";
               setalert = 1;
             }
         }
      
      
     if(C>C1&&C1>C2&&C2>C3)
         {
            ReverUP[shift1] = Low[shift1] - Range*0.2;
            RevDown[shift1] = High[shift1] + Range*0.2;
         }
           
         
         else
       
       if(C<C1&&C1<C2&&C2<C3/*||C>C1&&C1>C2*/)
       {
       BearDown[shift1] = Low[shift1] - Range*0.2;
       BearUp[shift1] = High[shift1] + Range*0.2;
        }
     } // End of for loop
   return(0);
  }